package com.example.e_systemmobile.adapters;

import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.RecyclerView;

import com.example.e_systemmobile.R;
import com.example.e_systemmobile.helperutils.Converter;
import com.example.e_systemmobile.models.Attendance;

import org.w3c.dom.Text;

import java.util.ArrayList;

public class AttendancesCourseAdapter extends RecyclerView.Adapter<AttendancesCourseAdapter.AttendancesCourseViewHolder> {

    ArrayList<Attendance> mAttendances = null;

    @NonNull
    @Override
    public AttendancesCourseViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        LayoutInflater inflater = LayoutInflater.from(parent.getContext());
        View view = inflater.inflate(R.layout.attendances_list_item, parent, false);
        return new AttendancesCourseViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull AttendancesCourseViewHolder holder, int position) {
        holder.mTextViewPresent.setText(Converter.convertStringToCapitalized(mAttendances.get(position).getIsPresent()));
        holder.mTextViewDate.setText(mAttendances.get(position).getDate());
        holder.mTextViewPoint.setText(mAttendances.get(position).getPoint());
    }

    @Override
    public int getItemCount() {
        if (mAttendances == null) return 0;
        return mAttendances.size();
    }

    public void setAttendancesData(ArrayList<Attendance> attendances) {
        mAttendances = attendances;
        notifyDataSetChanged();
    }

    public class AttendancesCourseViewHolder extends RecyclerView.ViewHolder {

        private final TextView mTextViewDate;
        private final TextView mTextViewPresent;
        private final TextView mTextViewPoint;


        public AttendancesCourseViewHolder(@NonNull View itemView) {
            super(itemView);
            mTextViewDate = itemView.findViewById(R.id.tv_attendances_date_value);
            mTextViewPoint = itemView.findViewById(R.id.tv_attendances_is_point_value);
            mTextViewPresent = itemView.findViewById(R.id.tv_attendances_is_presented_value);
        }
    }

}
