package com.example.e_systemmobile.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.e_systemmobile.R;
import com.example.e_systemmobile.models.Student;

import java.util.ArrayList;

public class ParticipantsEnrolledAdapter extends RecyclerView.Adapter<ParticipantsEnrolledAdapter.ParticipantsEnrolledViewHolder> {

    ArrayList<Student> mStudents;

    public ParticipantAdapterOnClick mParticipantOnClick;

    public interface ParticipantAdapterOnClick{
        void studentOnClick(String firstName, String lastName, String studentId);
    }

    public ParticipantsEnrolledAdapter(ParticipantAdapterOnClick mParticipantOnClick) {
        this.mParticipantOnClick = mParticipantOnClick;
    }

    @NonNull
    @Override
    public ParticipantsEnrolledViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        View view = layoutInflater.inflate(R.layout.participants_list_item, parent, false);
        return new ParticipantsEnrolledViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ParticipantsEnrolledViewHolder holder, int position) {
        holder.mTextViewName.setText(mStudents.get(position).getFirstName().trim() + " " + mStudents.get(position).getLastName().trim());
    }

    @Override
    public int getItemCount() {
        if(mStudents == null) return 0;
        return mStudents.size();
    }

    public void setParticipantsData(ArrayList<Student> students) {
        mStudents = students;
        notifyDataSetChanged();
    }

    public class ParticipantsEnrolledViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {

        private final TextView mTextViewName;
        public ParticipantsEnrolledViewHolder(@NonNull View view) {
            super(view);
            mTextViewName = view.findViewById(R.id.tv_participant_name);
            view.setOnClickListener(this);
        }

        @Override
        public void onClick(View v) {
            mParticipantOnClick.studentOnClick(mStudents.get(getAdapterPosition()).getFirstName(),
                    mStudents.get(getAdapterPosition()).getLastName(),
                    mStudents.get(getAdapterPosition()).get_id());
        }
    }
}
