package com.example.e_systemmobile.adapters;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.Lifecycle;
import androidx.viewpager2.adapter.FragmentStateAdapter;

import com.example.e_systemmobile.ui.dashboard.tabattendance.TabAttendance;
import com.example.e_systemmobile.ui.dashboard.tabcourse.TabCourse;
import com.example.e_systemmobile.ui.dashboard.tabgrades.TabGrades;
import com.example.e_systemmobile.ui.dashboard.tabparticipants.TabParticipants;

public class SingleCourseOverviewAdapter extends FragmentStateAdapter {

    private final Fragment[] mFragments = new Fragment[]{new TabCourse(), new TabParticipants(), new TabAttendance(), new TabGrades()};
    private String mCourseId;
    public SingleCourseOverviewAdapter(@NonNull FragmentManager fragmentManager, @NonNull Lifecycle lifecycle) {
        super(fragmentManager, lifecycle);
    }

    public void setCourseId(String courseId){
        mCourseId = courseId;
    }

    @NonNull
    @Override
    public Fragment createFragment(int position) {
        Fragment fragment = mFragments[position];
        Bundle args = new Bundle();
        args.putString("COURSE_ID", mCourseId);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public int getItemCount() {
        return mFragments.length;
    }
}
