package com.example.e_systemmobile.networkutils;

import com.example.e_systemmobile.models.Attendance;
import com.example.e_systemmobile.models.Course;
import com.example.e_systemmobile.models.QRSession;
import com.example.e_systemmobile.models.ResAuthObj;
import com.example.e_systemmobile.models.Student;
import com.example.e_systemmobile.models.SubmittedResponse;
import com.example.e_systemmobile.models.UserAuth;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.PATCH;
import retrofit2.http.POST;
import retrofit2.http.Query;

public interface RESTService {
    @POST("mobile/auth")
    Call<ResAuthObj> login(@Body UserAuth userAuth);

    @GET("mobile")
    Call<ArrayList<Course>> getCourses(@Query("token") String token);

    @GET("mobile/course/participants")
    Call<ArrayList<Student>> getParticipants(@Query("token") String token, @Query("_id") String _id);

    @GET("mobile/course/attendances")
    Call<ArrayList<Attendance>> getAttendances(@Query("token") String token, @Query("_id") String _id);

    @GET("mobile/course/attendances/qrsession")
    Call<QRSession> getQRSession(@Query("token") String token, @Query("sessionId") String sessionId);

    @PATCH("mobile/course/attendances/qrsession")
    Call<SubmittedResponse> getResponseUpdatedAttendance(@Query("token") String token, @Query("unitSessionId") String unitSessionId);
}
