package com.example.e_systemmobile.ui.dashboard;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import com.example.e_systemmobile.models.Course;
import com.example.e_systemmobile.networkutils.RESTService;
import com.example.e_systemmobile.networkutils.RetrofitClient;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class DashboardViewModel extends ViewModel {
    private String token;
    RESTService mRESTService;
    public DashboardViewModel(String token, RESTService restService){
        this.token = token;
        this.mRESTService = restService;
    }

    public LiveData<ArrayList<Course>> getMutableLiveDataCourses() {
        MutableLiveData<ArrayList<Course>> mutableLiveDataCourses= new MutableLiveData<>();
        if(token != null || token.isEmpty()){
            mRESTService.getCourses(token).enqueue(new Callback<ArrayList<Course>>() {
                @Override
                public void onResponse(Call<ArrayList<Course>> call, Response<ArrayList<Course>> response) {
                    if(response.isSuccessful()){
                        mutableLiveDataCourses.setValue(response.body());
                    }
                }
                @Override
                public void onFailure(Call<ArrayList<Course>> call, Throwable t) {
                    mutableLiveDataCourses.setValue(null);
                }
            });
        }
        else {
            mutableLiveDataCourses.setValue(null);
        }
        return mutableLiveDataCourses;
    }
}