package com.example.e_systemmobile.ui.qrscan;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.navigation.Navigation;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import com.budiyev.android.codescanner.CodeScanner;
import com.budiyev.android.codescanner.DecodeCallback;
import com.example.e_systemmobile.R;
import com.example.e_systemmobile.databinding.FragmentQRScanBinding;
import com.example.e_systemmobile.helperutils.ConstantVariable;
import com.example.e_systemmobile.models.QRSession;
import com.example.e_systemmobile.networkutils.ApiUtils;
import com.example.e_systemmobile.networkutils.RESTService;
import com.google.zxing.Result;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class QRScanFragment extends Fragment {
    private FragmentQRScanBinding binding;
    private CodeScanner mCodeScanner;

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentQRScanBinding.inflate(inflater, container, false);
        View root = binding.getRoot();
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        mCodeScanner = new CodeScanner(getContext(), binding.qrcodeScannerView);
        mCodeScanner.setDecodeCallback(result -> getActivity().runOnUiThread(() -> {
            if (!result.getText().isEmpty()) {
                Bundle args = new Bundle();
                args.putString(ConstantVariable.LOCATION_COURSE, result.getText().trim());
                Navigation.findNavController(getActivity(), R.id.fragment_QRCode_ContainerView).navigate(R.id.action_QRScanFragment_to_attendanceFragment, args);
            }
        }));
        mCodeScanner.startPreview();
    }

    @Override
    public void onPause() {
        super.onPause();
        mCodeScanner.releaseResources();
    }

    @Override
    public void onResume() {
        super.onResume();
        mCodeScanner.startPreview();
    }
}